#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <unistd.h>

#include <constants.h>
#include <dio96.h>
#include <structdef.h>
#include <global_variables.h>
#include <function_declarations.h>

#define MAX_CLIENTS	20

int main(int argc, char *argv[])
{
	int server_sockfd, client_sockfd, server_len, client_len;
	int i, nread, result, fd, highest_fd;
	//int j, k /* uncomment for printout of DIOs in for loop below */
	fd_set readfds, testfds;
	struct sockaddr_in server_address;
	struct sockaddr_in client_address;

	int fd_log[MAX_CLIENTS];
	unsigned char dio_status_current[96];
	char incoming[2];

	dio_variable_struct *dio_variables_ptr;
        dio_variables_ptr = &dio_variables;

 	// HARDWARE SPECIFIC INIT ROUTINES (DIO)
        i = open_dio_board(dio_variables_ptr);
	i = populate_ioctls(dio_variables_ptr);

	for (i = 0; i <= MAX_CLIENTS; i++)
		fd_log[i] = 0;

	server_sockfd = socket(AF_INET, SOCK_STREAM, 0);
	server_address.sin_family = AF_INET;
	server_address.sin_addr.s_addr = htonl(INADDR_ANY);
	server_address.sin_port = htons(9734);
	server_len = sizeof(server_address);

	bind(server_sockfd, (struct sockaddr *)&server_address, server_len);
	listen(server_sockfd, 5);

	FD_ZERO(&readfds);
	FD_SET(server_sockfd, &readfds);

	highest_fd = server_sockfd;
	while(1) {

                testfds = readfds;
		result = select(FD_SETSIZE, &testfds, (fd_set *)0, (fd_set *)0, (struct timeval *) 0);
		if(result < 1) {
			perror("dio_server error");
			exit(1);
		}

		for(fd = 0; fd <= highest_fd; fd++) {
			if(FD_ISSET(fd,&testfds)) {
				if(fd == server_sockfd) {
					client_sockfd = accept(server_sockfd, (struct sockaddr *)&client_address, &client_len);
					FD_SET(client_sockfd, &readfds);
					//printf("adding client on fd %d\n", client_sockfd);

					if (client_sockfd > highest_fd) highest_fd = client_sockfd;
				}
				else {
					ioctl(fd, FIONREAD, &nread);

					if(nread == 0) {
						close(fd);
						FD_CLR(fd, &readfds);
						//printf("removing client on fd %d\n", fd);
						if (fd == highest_fd)
							highest_fd --;
					}
					else {
						read(fd, &incoming, nread);
						if (incoming[0] == 'H' || incoming[0] == 'L' || incoming[0] == 'S'){
							//printf("message %c\n", incoming[0]);
							if (incoming[0] == 'H' || incoming[0] == 'L')
								write_digital_outputs(dio_variables_ptr, incoming[0], incoming[1]);
							read_digital_inputs(dio_variables_ptr, dio_status_current);
						        //for (j = 0; j <= 11; j++){
						        //	for (i = 0; i <= 7; i++){
							//		k = (j * 8) + i;
						        //		printf("%i: %i\t", k, dio_status_current[k]);
						        //	}
						        //	printf("\n");
						        //}
                                                        //printf("message received: %c\t", incoming[0]);
                                                        //for (i = 0; i <= 95; i++){
                                                                //dio_status_current[i] = dio_status_current[i] + 49;
                                                        //        printf("%i", dio_status_current[i]);
                                                        //}
                                                        //printf("\n");
                                                        write(fd, dio_status_current, 96);
						}
					}
				}
			}
		}
	}

        i = close_dio_board(dio_variables_ptr);
        return(1);
}

void parse_initialization_textfile(char *textfile, short *chip_init_array, short *bit_init_array)
{
        int i, j, k;
        int string_len, equal_sign_position;
	char dio_config_array[55];
	char dio_config_array_2[20];
	short dio_initialization_array[112];

	FILE *config_file;
	
	config_file=fopen(textfile, "r");
	k = 0;
	while((fgets(dio_config_array, 50, config_file) != NULL)){
 		string_len = strlen(dio_config_array) - 1;
 		dio_config_array[string_len] = 0; // strip off CR/LF at end of line
		for (j = 0; j <= string_len; j++)
			if (dio_config_array[j] == 0x3D) equal_sign_position = j;		
		for (i = 0, j = (equal_sign_position + 1); j <= string_len; i++, j++)
			dio_config_array_2[i] = dio_config_array[j];
		if (!strcmp(dio_config_array_2, "INPUT")) dio_initialization_array[k] = 1;
		if (!strcmp(dio_config_array_2, "OUTPUT")) dio_initialization_array[k] = 0;
		if (!strcmp(dio_config_array_2, "OFF")) dio_initialization_array[k] = 0;
		if (!strcmp(dio_config_array_2, "ON")) dio_initialization_array[k] = 1;
		k++;
						
	}	
	fclose(config_file);
	for (i = 0; i <=15; i++)
		chip_init_array[i] = dio_initialization_array[i];
	for (i = 0; i <= 95; i++)
		bit_init_array[i] = dio_initialization_array[i + 16];


}
