#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <stdio.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <string.h>
#include <sys/ioctl.h>
#include <time.h>
#include <stdlib.h>
#include <sys/time.h>

#include <constants.h>
#include <functions.h>

int main(int argc, char *argv[])
{
	int dio_number, requested_state, log_flag, predelay, postdelay;
	int i, len, sockfd, result, block_flag;
	
	//pid_t new_pid, child_pid;
	struct sockaddr_in address;


	if ((argc < 3) || (argc > 6)){
		printf("dio_toggle: bad parameters. Usage: dio_toggle <dio number> <on/off/req> [-log] [-delay n].  Exiting.\n");
		return(-1);
		}

	dio_number = atoi(argv[1]);
	if (dio_number < 0 || dio_number > 95){
		printf("dio_toggle: bad parameter. Argument 1 must be a number between 0 and 95.  Exiting.\n");
		return(-1);
		}
		
	if	(!strcmp(argv[2], "off"))
			requested_state = 1;
	else if	(!strcmp(argv[2], "on"))
			requested_state = 0;
	else if (!strcmp(argv[2], "req"))
			requested_state = -1;
	else printf("dio_toggle: bad parameter. Argument 2 must be on/off/req.  Exiting.\n");

	log_flag = 0;
	predelay = 0;
	postdelay = 0;
	for (i = 3; i < argc; i++){
		if (!strcmp(argv[i], "-log"))
			log_flag = 1;
		else if (!strcmp(argv[i], "-predelay"))
			predelay = atoi(argv[i + 1]);
		else if (!strcmp(argv[i], "-postdelay"))
			postdelay = atoi(argv[i + 1]);
		}

	sockfd = socket(AF_INET, SOCK_STREAM, 0);
	address.sin_family = AF_INET;
	address.sin_addr.s_addr = inet_addr("127.0.0.1");
	address.sin_port = htons(9734);
	len = sizeof(address);
	result = connect(sockfd, (struct sockaddr *)&address, len);
	if(result == -1) {
		printf("dio_toggle: cannot connect to DIO server.  Exiting\n");
		return(-1);
	}
	
	block_flag = NO_BLOCK_FLAG;
	ioctl(sockfd, FIONBIO, &block_flag);

	//check_dio_locks("/var/lock/dio_locks/dio80");
	result = dio_toggle(sockfd, dio_number, requested_state, log_flag, predelay, postdelay);
	return(result);

}
